

from practicum import find_mcu_boards, McuBoard, PeriBoard
from time import sleep
from datetime import datetime
import sys
import time
import datetime
import RPi.GPIO as GPIO
import tm1637
import random

# 4 digit
#CLK -> GPIO23 (Pin 16)
#DI0 -> GPIO24 (Pin 18)
Display = tm1637.TM1637(23,24,tm1637.BRIGHT_TYPICAL)
Display.Clear()
Display.SetBrightnes(8)
devs = find_mcu_boards()

#buzzer -> GPIO25
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
BUZZER= 25
buzzState = False
GPIO.setup(BUZZER, GPIO.OUT)
GPIO.setup(26, GPIO.OUT) #led

#############################################################
if len(devs) == 0:
    print("*** No practicum board found.")
    exit(1)

mcu = McuBoard(devs[0])
print("*** Practicum board found")
print("*** Manufacturer: %s" % \
        mcu.handle.getString(mcu.device.iManufacturer, 256))
print("*** Product: %s" % \
        mcu.handle.getString(mcu.device.iProduct, 256))
peri = PeriBoard(mcu)

led=0
pcount = 0
alarm = 0
stack = 0
bus = "Off"
x = y = z = 0
c = 1
################################################################################
#set alarm BY user
maxstack = 10 #How many second of lazer hit
long =  3600  #How long to alarm(second)
alarmhour = 13
alarmminute = 17

#set date alarm
adate = 0
amount = 0
ayear = 0
################################################################################
################################################################################
while True:
    now = datetime.datetime.now()
    hour = now.hour
    minute = now.minute
    second = now.second

    #######################
    sw = peri.get_switch()
    light = peri.get_light()
    if sw is True:
        state = "ON"
    else:
        state = "OFF"
    #######################

    if (int(hour)==alarmhour and int(minute)==alarmminute and int(second)==0):
        alarm = 3600
    else:
        if alarm>=0:
            led = 1
            bus="On"
            GPIO.output(BUZZER, 0)
        else:
            bus = "Off"
            GPIO.output(BUZZER, 0)
            stack = 0
            if (pcount%2==1):
                led = 7
            else:
                led = 4
    peri.set_led_value(led)
    #######################################################################
    if (alarm>0):
        x = random.randint(0,1)

        if (sw is True and (y==1)):
            stack = stack + 1
            state = "good"
            y = x
        elif (sw is False and (y==0)):
            stack = stack + 0
            state = "good"
            z = y
            y = x
        else:
            state = "miss"
            stack = 0
            y = x
        #ran = gpio26
        GPIO.output(26, x)
        if (stack==maxstack):
            alarm = 0
        current = [ int(stack / 10), stack % 10, int(maxstack / 10), maxstack % 10 ]
        Display.Show(current)
        Display.ShowDoublepoint(1)
    else :
        x = y = z = 0
        GPIO.output(26, 0)
        currenttime = [ int(hour / 10), hour % 10, int(minute / 10), minute % 10 ]
        Display.Show(currenttime)
        Display.ShowDoublepoint(second % 2)
    #######################################################################
    print(now,"[LEDstateNO: ",led,"] [BuzzerState: ",bus,"]  [Stack :",stack,"/",maxstack,"] [ishit?: ",state,
              "] Ran=",x)
    alarm = alarm - 1
    pcount = pcount + 1
    sleep(0.5)
    GPIO.output(BUZZER, 0)
    sleep(0.5)


